//+------------------------------------------------------------------+
//|                                                         alma.mq4 |
//|                                              converted by mladen |
//|                                               mladenfx@gmail.com |
//+------------------------------------------------------------------+
#property copyright "www.forex-station.com"
#property link      "www.forex-station.com"
#property strict
#property indicator_chart_window
#property indicator_buffers 9
#property indicator_label1  "Alma"
#property indicator_type1   DRAW_LINE
#property indicator_color1  clrLimeGreen  
#property indicator_width1  14
#property indicator_label2  "Alma"
#property indicator_type2   DRAW_LINE
#property indicator_color2  clrOrange
#property indicator_width2  14
#property indicator_label3  "Alma"
#property indicator_type3   DRAW_LINE
#property indicator_color3  clrOrange  
#property indicator_width3  14

#property indicator_label4  "Alma"
#property indicator_type4   DRAW_LINE
#property indicator_color4  clrHoneydew
#property indicator_width4  11
#property indicator_label5  "Alma"
#property indicator_type5   DRAW_LINE
#property indicator_color5  clrPapayaWhip
#property indicator_width5  11
#property indicator_label6  "Alma"
#property indicator_type6   DRAW_LINE
#property indicator_color6  clrPapayaWhip
#property indicator_width6  11

#property indicator_label7  "Alma"
#property indicator_type7   DRAW_LINE
#property indicator_color7  clrLimeGreen
#property indicator_width7  3
#property indicator_label8  "Alma"
#property indicator_type8   DRAW_LINE
#property indicator_color8  clrOrange
#property indicator_width8  3
#property indicator_label9  "Alma"
#property indicator_type9   DRAW_LINE
#property indicator_color9  clrOrange
#property indicator_width9  3

//
//
//

input int              inpAlmaPeriod        = 34;                // Alma period
input double           inpAlmaSigma         = 6.0;               // Alma sigma
input double           inpAlmaSample        = 0.25;              // Alma sample
enum  enPrices
      {
         pr_close,                                               // Close
         pr_open,                                                // Open
         pr_high,                                                // High
         pr_low,                                                 // Low
         pr_median,                                              // Median
         pr_typical,                                             // Typical
         pr_weighted,                                            // Weighted
         pr_average,                                             // Average (high+low+open+close)/4
         pr_medianb,                                             // Average median body (open+close)/2
         pr_tbiased,                                             // Trend biased price
         pr_tbiased2,                                            // Trend biased (extreme) price
         pr_haclose,                                             // Heiken ashi close
         pr_haopen,                                              // Heiken ashi open
         pr_hahigh,                                              // Heiken ashi high
         pr_halow,                                               // Heiken ashi low
         pr_hamedian,                                            // Heiken ashi median
         pr_hatypical,                                           // Heiken ashi typical
         pr_haweighted,                                          // Heiken ashi weighted
         pr_haaverage,                                           // Heiken ashi average
         pr_hamedianb,                                           // Heiken ashi median body
         pr_hatbiased,                                           // Heiken ashi trend biased price
         pr_hatbiased2,                                          // Heiken ashi trend biased (extreme) price
         pr_habclose,                                            // Heiken ashi (better formula) close
         pr_habopen,                                             // Heiken ashi (better formula) open
         pr_habhigh,                                             // Heiken ashi (better formula) high
         pr_hablow,                                              // Heiken ashi (better formula) low
         pr_habmedian,                                           // Heiken ashi (better formula) median
         pr_habtypical,                                          // Heiken ashi (better formula) typical
         pr_habweighted,                                         // Heiken ashi (better formula) weighted
         pr_habaverage,                                          // Heiken ashi (better formula) average
         pr_habmedianb,                                          // Heiken ashi (better formula) median body
         pr_habtbiased,                                          // Heiken ashi (better formula) trend biased price
         pr_habtbiased2                                          // Heiken ashi (better formula) trend biased (extreme) price
      };
input enPrices         inpPrice              = pr_close;         // Price to use 
input double           inpFilter             = 0;                // Filter to use (<=0, no filter)
input int              inpFilPeriod          = 0;                // Filter period to use (<=0 the same as main period)
      enum enFilterWhat
      {
         flt_prc,                                                // Filter the price
         flt_val,                                                // Filter the result value
         flt_both,                                               // Filter both
      };
input enFilterWhat      inpFilterOn          = flt_both;         // Apply filter to :
input bool              alertsOn             = false;            // Alerts true/false?
input bool              alertsOnCurrent      = false;            // Alerts open bar true/false?
input bool              alertsMessage        = false;            // Alerts message true/false?
input bool              alertsSound          = false;            // Alerts sound true/false?
input bool              alertsNotify         = false;            // Alerts push notification true/false?
input bool              alertsEmail          = false;            // Alerts email true/false?
input string            soundFile            = "alert2.wav";     // Sound file

double ALMAuptrend[],ALMAdowntrend[],ALMAfillingColor[],ALMAslope[];
double ALMAuptrend2[],ALMAdowntrend2[],ALMAfillingColor2[];
double ALMAuptrend3[],ALMAdowntrend3[],ALMAfillingColor3[];
int  filPer; 
//+------------------------------------------------------------------------------------------------------------------+
int OnInit()
{
   IndicatorBuffers(10);
   
   SetIndexBuffer(0,ALMAuptrend2     ,INDICATOR_DATA); 
   SetIndexBuffer(1,ALMAdowntrend2   ,INDICATOR_DATA); 
   SetIndexBuffer(2,ALMAfillingColor2,INDICATOR_DATA); 

   SetIndexBuffer(3,ALMAuptrend3     ,INDICATOR_DATA); 
   SetIndexBuffer(4,ALMAdowntrend3   ,INDICATOR_DATA); 
   SetIndexBuffer(5,ALMAfillingColor3,INDICATOR_DATA); 

   SetIndexBuffer(6,ALMAuptrend      ,INDICATOR_DATA); //clrLimeGreen
   SetIndexBuffer(7,ALMAdowntrend    ,INDICATOR_DATA); //clrOrange
   SetIndexBuffer(8,ALMAfillingColor ,INDICATOR_DATA); //clrDimGray

   SetIndexBuffer(9,ALMAslope);
   
   filPer = (inpFilPeriod>0) ? inpFilPeriod : inpAlmaPeriod;
   
   IndicatorSetString(INDICATOR_SHORTNAME,"ALMA ("+(string)inpAlmaPeriod+","+DoubleToStr(inpAlmaSigma,2)+","+DoubleToStr(inpAlmaSample,2)+")");
return(INIT_SUCCEEDED);
}
//+------------------------------------------------------------------------------------------------------------------+
void OnDeinit(const int reason) { }
//+------------------------------------------------------------------------------------------------------------------+

int  OnCalculate(const int rates_total,const int prev_calculated,const datetime &time[],
                const double &open[],
                const double &high[],
                const double &low[],
                const double &close[],
                const long &tick_volume[],
                const long &volume[],
                const int &spread[])
{
   int i=rates_total-prev_calculated+1; if (i>=rates_total) i=rates_total-1; 
   
   //
   //
   //
   
   if (ALMAslope[i]==-1) iCleanPoint(i,ALMAdowntrend,ALMAfillingColor);
   double pfilter = inpFilter; if (inpFilterOn==flt_val) pfilter=0;
   double vfilter = inpFilter; if (inpFilterOn==flt_prc) vfilter=0;
   for (; i>=0 && !_StopFlag; i--)
   {
      double prc  = iFilter(getPrice(inpPrice,open,high,low,close,i,rates_total),pfilter,filPer,i,rates_total,0);
         ALMAuptrend[i]   = iFilter(iAlma(prc,inpAlmaPeriod,inpAlmaSigma,inpAlmaSample,rates_total,i),pfilter,filPer,i,rates_total,1);
         ALMAslope[i]  = (i<rates_total-1) ? (ALMAuptrend[i]>ALMAuptrend[i+1]) ? 1 : (ALMAuptrend[i]<ALMAuptrend[i+1]) ? -1 : ALMAslope[i+1] : 0;
         ALMAdowntrend[i] = ALMAfillingColor[i] = EMPTY_VALUE;  if (ALMAslope[i] == -1) iPlotPoint(i,ALMAdowntrend,ALMAfillingColor,ALMAuptrend);

         ALMAuptrend2[i] = ALMAuptrend[i];
         ALMAdowntrend2[i] = ALMAdowntrend[i];
         ALMAfillingColor2[i] = ALMAfillingColor[i];         

         ALMAuptrend3[i] = ALMAuptrend[i];
         ALMAdowntrend3[i] = ALMAdowntrend[i];
         ALMAfillingColor3[i] = ALMAfillingColor[i];         
   }
   if (alertsOn)
   {
      int whichBar = 1; if (alertsOnCurrent) whichBar = 0; 
      if (ALMAslope[whichBar] != ALMAslope[whichBar+1])
      {
         if (ALMAslope[whichBar] == 1) doAlert(" sloping up");
         if (ALMAslope[whichBar] ==-1) doAlert(" sloping down");       
      }         
   }        
return(rates_total);
}
//+------------------------------------------------------------------------------------------------------------------+
//    Alma function                                                
//+------------------------------------------------------------------------------------------------------------------+

#define almaInstances 1
double  almaWork[][almaInstances];
double iAlma(double price, int period, double sigma, double sample, int bars, int r, int instanceNo=0)
{
   if (period<=1) return(price);
   if (ArrayRange(almaWork,0)!=bars) ArrayResize(almaWork,bars); r=bars-r-1; almaWork[r][instanceNo] = price;
   
   //
   //
   //

   double m = floor(sample * (period - 1.0));
   double s = period/sigma, sum=0, div=0;
   for (int i=0; i<period && (r-i)>=0; i++)
      {
         double coeff = exp(-((i-m)*(i-m))/(2.0*s*s));
            sum += coeff*almaWork[r-i][instanceNo];
            div += coeff;
      }
   double talma = price; if (div!=0) talma = sum/div;
   return(talma);
}

//+------------------------------------------------------------------------------------------------------------------+
//     Filter function                                                             
//+------------------------------------------------------------------------------------------------------------------+

#define filterInstances 2
double workFil[][filterInstances*3];

#define _fchange 0
#define _fachang 1
#define _fprice  2

double iFilter(double tprice, double filter, int period, int i, int bars, int instanceNo=0)
{
   if (filter<=0) return(tprice);
   if (ArrayRange(workFil,0)!= bars) ArrayResize(workFil,bars); i = bars-i-1; instanceNo*=3;
   
   //
   //
   //
   //
   //
   
   workFil[i][instanceNo+_fprice]  = tprice; if (i<1) return(tprice);
   workFil[i][instanceNo+_fchange] = fabs(workFil[i][instanceNo+_fprice]-workFil[i-1][instanceNo+_fprice]);
   workFil[i][instanceNo+_fachang] = workFil[i][instanceNo+_fchange];

   for (int k=1; k<period && (i-k)>=0; k++) workFil[i][instanceNo+_fachang] += workFil[i-k][instanceNo+_fchange];
                                            workFil[i][instanceNo+_fachang] /= period;
    
   double stddev = 0; for (int k=0;  k<period && (i-k)>=0; k++) stddev += pow(workFil[i-k][instanceNo+_fchange]-workFil[i-k][instanceNo+_fachang],2);
          stddev = sqrt(stddev/(double)period); 
   double filtev = filter * stddev;
   if(fabs(workFil[i][instanceNo+_fprice]-workFil[i-1][instanceNo+_fprice]) < filtev ) workFil[i][instanceNo+_fprice]=workFil[i-1][instanceNo+_fprice];
return(workFil[i][instanceNo+_fprice]);
}

//+------------------------------------------------------------------------------------------------------------------+
//  Price function
//+------------------------------------------------------------------------------------------------------------------+

double getPrice(int tprice, const double& open[], const double& high[], const double& low[], const double& close[], int i, int bars)
{
   if (tprice>=pr_haclose)
   {
      struct sHaStruct
      {
         double open;
         double high;
         double low;
         double close;
      };
      static sHaStruct m_array[];
      static int       m_arraySize = -1;
                   if (m_arraySize<bars) m_arraySize = ArrayResize(m_array,bars+500);
                   
         //
         //
         //
                            
         #ifdef __MQL4__                  
            int r = bars-i-1;
         #else            
            int r = i;
         #endif            
         
         //
         //
         //
         
         double haOpen  = (r>0) ? (m_array[r-1].open + m_array[r-1].close)/2.0 : (open[i]+close[i])/2;;
         double haClose = (open[i]+high[i]+low[i]+close[i]) / 4.0;
         #define _prHABF(_prtype) (_prtype>=pr_habclose && _prtype<=pr_habtbiased2)
            if (_prHABF(tprice))
                  if (high[i]!=low[i])
                        haClose = (open[i]+close[i])/2.0+(((close[i]-open[i])/(high[i]-low[i]))*fabs((close[i]-open[i])/2.0));
                  else  haClose = (open[i]+close[i])/2.0; 
         #undef  _prHABF                  
         double haHigh  = fmax(high[i],fmax(haOpen,haClose));
         double haLow   = fmin(low[i] ,fmin(haOpen,haClose));

         //
         //
         //
         
         if(haOpen<haClose) { m_array[r].high  = haLow;  m_array[r].low = haHigh; } 
         else               { m_array[r].high  = haHigh; m_array[r].low = haLow;  } 
                              m_array[r].open  = haOpen;
                              m_array[r].close = haClose;
         //
         //
         //
         
         switch (tprice)
         {
            case pr_haclose:
            case pr_habclose:    return(haClose);
            case pr_haopen:   
            case pr_habopen:     return(haOpen);
            case pr_hahigh: 
            case pr_habhigh:     return(haHigh);
            case pr_halow:    
            case pr_hablow:      return(haLow);
            case pr_hamedian:
            case pr_habmedian:   return((haHigh+haLow)/2.0);
            case pr_hamedianb:
            case pr_habmedianb:  return((haOpen+haClose)/2.0);
            case pr_hatypical:
            case pr_habtypical:  return((haHigh+haLow+haClose)/3.0);
            case pr_haweighted:
            case pr_habweighted: return((haHigh+haLow+haClose+haClose)/4.0);
            case pr_haaverage:  
            case pr_habaverage:  return((haHigh+haLow+haClose+haOpen)/4.0);
            case pr_hatbiased:
            case pr_habtbiased:
               if (haClose>haOpen)
                     return((haHigh+haClose)/2.0);
               else  return((haLow+haClose)/2.0);        
            case pr_hatbiased2:
            case pr_habtbiased2:
               if (haClose>haOpen)  return(haHigh);
               if (haClose<haOpen)  return(haLow);
                                    return(haClose);        
         }
   }
   
   //
   //
   //

   switch (tprice)
   {
      case pr_close:     return(close[i]);
      case pr_open:      return(open[i]);
      case pr_high:      return(high[i]);
      case pr_low:       return(low[i]);
      case pr_median:    return((high[i]+low[i])/2.0);
      case pr_medianb:   return((open[i]+close[i])/2.0);
      case pr_typical:   return((high[i]+low[i]+close[i])/3.0);
      case pr_weighted:  return((high[i]+low[i]+close[i]+close[i])/4.0);
      case pr_average:   return((high[i]+low[i]+close[i]+open[i])/4.0);
      case pr_tbiased:   
               if (close[i]>open[i])
                     return((high[i]+close[i])/2.0);
               else  return((low[i]+close[i])/2.0);        
      case pr_tbiased2:   
               if (close[i]>open[i]) return(high[i]);
               if (close[i]<open[i]) return(low[i]);
                                     return(close[i]);        
   }
   return(0);
}

//
//
//
//+------------------------------------------------------------------------------------------------------------------+
void iCleanPoint(int i,double& first[],double& second[])
{
   if (i>=Bars-3) return;
   if ((second[i]  != EMPTY_VALUE) && (second[i+1] != EMPTY_VALUE))
        second[i+1] = EMPTY_VALUE;
   else
      if ((first[i] != EMPTY_VALUE) && (first[i+1] != EMPTY_VALUE) && (first[i+2] == EMPTY_VALUE))
          first[i+1] = EMPTY_VALUE;
}
void iPlotPoint(int i,double& first[],double& second[],double& from[])
{
   if (i>=Bars-2) return;
   if (first[i+1] == EMPTY_VALUE)
      if (first[i+2] == EMPTY_VALUE) 
            { first[i]  = from[i];  first[i+1]  = from[i+1]; second[i] = EMPTY_VALUE; }
      else  { second[i] =  from[i]; second[i+1] = from[i+1]; first[i]  = EMPTY_VALUE; }
   else     { first[i]  = from[i];                           second[i] = EMPTY_VALUE; }
}
//+------------------------------------------------------------------------------------------------------------------+

//
//
//

string sTfTable[] = {"M1","M5","M15","M30","H1","H4","D1","W1","MN"};
int    iTfTable[] = {1,5,15,30,60,240,1440,10080,43200};

string timeFrameToString(int tf)
{
   for (int i=ArraySize(iTfTable)-1; i>=0; i--) 
         if (tf==iTfTable[i]) return(sTfTable[i]);
                              return("");
}

//+------------------------------------------------------------------------------------------------------------------+
// Alert function
//+------------------------------------------------------------------------------------------------------------------+

void doAlert(string doWhat)
{
   static string   previousAlert="nothing";
   static datetime previousTime;
   string message;
   
      if (previousAlert != doWhat || previousTime != Time[0]) {
          previousAlert  = doWhat;
          previousTime   = Time[0];

          //
          //
          //
          //
          //

          message = timeFrameToString(_Period)+" "+_Symbol+" at "+TimeToStr(TimeLocal(),TIME_SECONDS)+" Alma "+doWhat;
             if (alertsMessage) Alert(message);
             if (alertsNotify)  SendNotification(message);
             if (alertsEmail)   SendMail(_Symbol+" Alma ",message);
             if (alertsSound)   PlaySound(soundFile);
      }
}
//+------------------------------------------------------------------------------------------------------------------+


